#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;
using Syncfusion.Drawing;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// The ChartControl sample form.
	/// </summary>
	public class FormMain : Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.CheckBox checkBox1;
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox comboBox1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeControlSettings();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
			this.panel1 = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.panel2 = new System.Windows.Forms.Panel();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.label1});
			this.panel1.Location = new System.Drawing.Point(936, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(200, 208);
			this.panel1.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 104);
			this.label1.Name = "label1";
			this.label1.TabIndex = 2;
			this.label1.Text = "Gradient Style";
			// 
			// checkBox1
			// 
			this.checkBox1.Checked = true;
			this.checkBox1.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBox1.Cursor = System.Windows.Forms.Cursors.Hand;
			this.checkBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.checkBox1.Location = new System.Drawing.Point(16, 40);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(112, 24);
			this.checkBox1.TabIndex = 0;
			this.checkBox1.Text = "Show Interior Color";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checked_changed);
			// 
			// chartControl1
			// 
			this.chartControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.chartControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.chartControl1.Legend});
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Location = new System.Drawing.Point(322, 187);
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = ChartOrientation.Horizontal;
			this.chartControl1.Size = new System.Drawing.Size(408, 374);
			this.chartControl1.TabIndex = 1;
			this.chartControl1.Text = "Essential Chart";
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
			// 
			// panel2
			// 
			this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel2.BackColor = System.Drawing.Color.White;
			this.panel2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.comboBox1,
																				 this.label2,
																				 this.checkBox1});
			this.panel2.Location = new System.Drawing.Point(408, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(144, 376);
			this.panel2.TabIndex = 2;
			// 
			// comboBox1
			// 
			this.comboBox1.Cursor = System.Windows.Forms.Cursors.Hand;
			this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBox1.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(146)), ((System.Byte)(35)));
			this.comboBox1.Location = new System.Drawing.Point(16, 128);
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(121, 21);
			this.comboBox1.TabIndex = 6;
			this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 104);
			this.label2.Name = "label2";
			this.label2.TabIndex = 5;
			this.label2.Text = "Gradient Style";
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.panel2,
																		  this.panel1,
																		  this.chartControl1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "FormMain";
			this.Text = "Essential Chart - Chart Interior Sample";
			this.Load += new System.EventHandler(this.FormMain_Load);
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitializeControlSettings()
	  {
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

		  // Specify a ChartPalette:
		  Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
		  this.chartControl1.Palette = ChartColorPalette.Custom ;
		  this.chartControl1.Model.ColorModel.CustomColors = color;
		  this.chartControl1.Palette = ChartColorPalette.Custom ;

		  this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
		  this.chartControl1.LegendPosition = ChartDock.Top;
		this.chartControl1.HidePartialLabels = true;
	  }

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		
		private void FormMain_Load(object sender, System.EventArgs e)
		{
			FillControlPanel();
			InitializeChartData();
			InitializeChartAppearance();
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			ChartSeries series1 = this.chartControl1.Model.NewSeries(" Chicago",ChartSeriesType.Area);
			series1.Text = series1.Name;

			series1.Points.Add(1,256);
			series1.Points.Add(2,491);
			series1.Points.Add(3,382);
			series1.Points.Add(4,437);
			series1.Points.Add(5,321);
			
			series1.Style.Font.Bold = true;

			ChartSeries series2 = this.chartControl1.Model.NewSeries(" NewYork",ChartSeriesType.Area );
			series2.Text = series2.Name;

			series2.Points.Add(1,437);
			series2.Points.Add(2,451);
			series2.Points.Add(3,490);
			series2.Points.Add(4,366);
			series2.Points.Add(5,422);
			
			series2.Style.Font.Bold = true;

			series1.PrepareStyle+=new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);
			series2.PrepareStyle+=new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);

			this.chartControl1.Series.Add(series1);
			this.chartControl1.Series.Add(series2);
			this.chartControl1.Text="Weekly Total Sales Volume";
			this.chartControl1.PrimaryXAxis.Format="Week 0";
			this.chartControl1.PrimaryYAxis.Title="Sales Volume (Million $)";
			this.chartControl1.PrimaryXAxis.LabelIntersectAction=ChartLabelIntersectAction.MultipleRows;
		}

		/// <summary>
		/// Sets properties to customize the ChartControl's appearance
		/// </summary>
		protected void InitializeChartAppearance()
		{
			this.chartControl1.Series[0].Style.Interior = new BrushInfo(155, new BrushInfo(GradientStyle.PathEllipse, new BrushInfoColorArrayList(new Color[]{Color.Blue, Color.Crimson})));
			this.chartControl1.Series[1].Style.Interior = new BrushInfo(155, new BrushInfo(GradientStyle.PathEllipse, new BrushInfoColorArrayList(new Color[]{Color.Orange, Color.White})));
		}	
	
		/// <summary>
		/// Handler for the PrepareStyle event of ChartSeries. 
		/// </summary>
		/// <param name="sender">The ChartSeries object that raises this event.</param>
		/// <param name="args">The event data. Can be modified to change series appearance.</param>
		
		private void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			if(series != null)
			{
				args.Style.Text = string.Format("Value is {0}", series.Points[args.Index].YValues[0]);
				args.Style.TextOrientation = ChartTextOrientation.Center;
				args.Style.Symbol.Size = new Size(15,15);
				args.Style.Symbol.Color = Color.Red;
				args.Style.DisplayShadow = true;

				if(series == this.chartControl1.Series[0])
					args.Style.Symbol.Shape = ChartSymbolShape.Cross;
				else
					args.Style.Symbol.Shape = ChartSymbolShape.Circle;
			}
		}

		private void checked_changed(object sender, System.EventArgs e)
		{
			SetInterior();
		}

		protected void FillControlPanel()
		{
			foreach(string gradient in Enum.GetNames(typeof(Syncfusion.Drawing.GradientStyle )))
				this.comboBox1.Items.Add(gradient);
			this.comboBox1.SelectedIndex = 4;
		}

		private void comboBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			SetInterior();
		}

		protected void SetInterior()
		{
			if(this.checkBox1.Checked)
			{
				this.chartControl1.ChartInterior = new BrushInfo((GradientStyle)Enum.Parse(typeof(GradientStyle),this.comboBox1.SelectedItem.ToString(),true), Color.LightBlue, Color.Azure  );
				this.chartControl1.Redraw(true);
			}
			else
			{
				this.chartControl1.ChartInterior = new BrushInfo(GradientStyle.Vertical, Color.Empty , Color.Empty );
				this.chartControl1.Redraw(true);
			}
		}
	}
}
